#include "bal.h"

uint32_t be32_to_cpup(uint8_t *p)
{
	return (p[0]<<24) | (p[1]<<16) | (p[2]<<8) | p[3];
}


uint64_t be64_to_cpup(uint8_t *p)
{
	uint64_t tmp = ((uint64_t)be32_to_cpup(p)) << 32;
	return tmp | be32_to_cpup(p+4);
}

uint64_t cpu_to_be64(uint64_t src)
{
	return be64_to_cpup((uint8_t *)&src);
}

void put_unaligned(uint64_t a, uint8_t *buf)
{
	int i;
	uint8_t *p = (uint8_t *)&a;

	for (i=0; i<8; i++)
		buf[i] = p[i];
}

