/*
 * DON'T USE. just a code memo. 
 *  this code trys to reset the IC card reader device in Friio,
 *  but in fact, it doesn't work at all. 
 */
#include <stdio.h>
#include <unistd.h>
#include <usb.h>

#define FRIIO_BCAS_VID 0x058f
#define FRIIO_BCAS_PID 0x9522

#define FRIIO_BCAS_CFG 1
#define FRIIO_BCAS_INTF 0
#define FRIIO_BCAS_EP_BULKOUT 0x02
#define FRIIO_BCAS_EP_BULKIN  0x83
#define FRIIO_BCAS_TIMEOUT 3000

#define CCID_CMD_BSEQ_IDX 6
#define CCID_DBLOCK_STAT_IDX 7
#define CCID_DBLOCK_ERR_IDX 8
#define CCID_DBLOCK_DATA_IDX 10

void
doProc(struct usb_device *dev)
{
	int ret, rlen, i;
	static unsigned char bSeq = 0;
	usb_dev_handle *h = usb_open(dev);

	unsigned char wbuf_powon[10] = {0x62, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char wbuf_abort[10] = {0x72, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char rbuf_dblock[256], rbuf_state[256];
	unsigned char *atr;

	if (!h) {
		perror("Failed to claim the USB dev.");
		return;
	}

/* Don't RESET, as it makes the dev die and requires a re-plugging.
	usb_reset(h);
	exit(0);
*/

//	usb_set_configuration(h, FRIIO_BCAS_CFG);
	ret = usb_claim_interface(h, FRIIO_BCAS_INTF);
	if (ret < 0) {
		perror("Failed to claim the interface.");
		usb_close(h);
		return;
	}

	usb_clear_halt(h, 0);
	usb_clear_halt(h, 0x81);
	usb_clear_halt(h, FRIIO_BCAS_EP_BULKOUT);
	usb_clear_halt(h, FRIIO_BCAS_EP_BULKIN);
        sleep(1);

	ret = usb_control_msg(h, 0x21, 0x01, 0x0000, 0x0000, NULL, 0, 5000);
	if (ret < 0) {
		perror("Failed to send ABORT.");
		usb_close(h);
		return;
	}

	ret = usb_bulk_write(h, FRIIO_BCAS_EP_BULKOUT,
				wbuf_abort, sizeof(wbuf_abort),
				FRIIO_BCAS_TIMEOUT);
	if (ret < 0) {
		perror("Failed to send BULK_ABORT.");
		usb_close(h);
		return;
	}
	do {
		ret = usb_bulk_read(h, FRIIO_BCAS_EP_BULKIN,
					rbuf_state, sizeof(rbuf_state),
					FRIIO_BCAS_TIMEOUT);
		if (ret < 10) {
			perror("Failed to recv BULK resp.");
			usb_close(h);
			return;
		}
	} while (rbuf_state[0] != 0x81 ||
		 !rbuf_state[5] || !rbuf_state[6] || !rbuf_state[7]);

	fprintf(stderr, "Sending IccPowerOn cmd.\n");
	wbuf_powon[CCID_CMD_BSEQ_IDX] = ++bSeq;
	ret = usb_bulk_write(h, FRIIO_BCAS_EP_BULKOUT,
			     wbuf_powon, sizeof(wbuf_powon),
			     FRIIO_BCAS_TIMEOUT);
	if (ret != sizeof(wbuf_powon)) {
		perror("Failed to send command.");
		goto bailout;
	}

	sleep(1);
	ret = usb_bulk_read(h, FRIIO_BCAS_EP_BULKIN,
			    rbuf_dblock, sizeof(rbuf_dblock),
			    FRIIO_BCAS_TIMEOUT);
	if (ret < 10) {
		perror("Failed to read response.");
		goto bailout;
	}
	rlen = (rbuf_dblock[4]<<24) | (rbuf_dblock[3]<<16) |
		(rbuf_dblock[2]<<8) | rbuf_dblock[1];

	if (rbuf_dblock[0] != 0x80 || rbuf_dblock[CCID_CMD_BSEQ_IDX] != bSeq) {
		fprintf(stderr, "Bad response. Type:0x%02hhx, Seq:0x%02hhx.\n",
			rbuf_dblock[0], rbuf_dblock[CCID_CMD_BSEQ_IDX]);
		goto bailout;
	}
	fprintf(stderr, "Response: bStatus:%02hhx bError:%02hhx ATR(%08x):",
		rbuf_dblock[CCID_DBLOCK_STAT_IDX],	
		rbuf_dblock[CCID_DBLOCK_ERR_IDX], rlen);
	atr = &rbuf_dblock[CCID_DBLOCK_DATA_IDX];
	for (i=0; i<rlen; i++) {
		fprintf(stderr, " %02hhx", atr[i]); 
	}
	fprintf(stderr, "\n");

bailout:
	usb_release_interface(h, FRIIO_BCAS_INTF);	
	usb_close(h);
	return;
}


int
main(int argc, char **argv)
{
	struct usb_bus *usb_bus;
	struct usb_device *dev;

	usb_init();
	usb_find_busses();
	usb_find_devices();

	for (usb_bus = usb_busses; usb_bus; usb_bus = usb_bus->next) {
		for (dev = usb_bus->devices; dev; dev = dev->next) {
			if (dev->descriptor.idVendor == FRIIO_BCAS_VID &&
			    dev->descriptor.idProduct == FRIIO_BCAS_PID)
				doProc(dev);
		}
	}
	return 0;
}
